<?php
class shoppingchart
{
  var $userinfo;
  var $itemlist;
  var $expiretime;
  function shoppingchart($userinfo="",$itemlist="",$expiretime){
    $this->userinfo=$userinfo;
    $this->itemlist=$itemlist;
    $this->expiretime=$expiretime;
  }
  function placeOrder(){
    $this->sendEmailToAdmin();
    $this->sendEmailToCustomer();
    $totalOrder=$this->getTotalOrder();
    $this->clearItem();
    return $totalOrder;
  }
  function sendEmailToCustomer(){
    global $admin_name,$admin_mail;
    $to = $this->getInfo(0)." <".$this->getInfo(1).">";
    $subject = "Order Placed";
    $message="Your order had been placed and will be dealt with as soon as your credit card payment has been processed by WorldPay.";
    $extraheader.="From: $admin_name<$admin_mail>\n";
    $extraheader.="Reply-To: $admin_mail\r\n";
    $extraheader.="X-Mailer: Hermawan Haryanto [hermawan@haryan.to]";
    @mail($to,$subject,$message,$extraheader);
  }
  function sendEmailToAdmin(){
    global $admin_name,$admin_mail;
    $to = "$admin_name <$admin_mail>";
    $subject = "Order Received";
    $message = "An order had been placed, below is the details.\n";
    $message.= "No.\tCode\tName\tPrice\tQuantity\tTotal\n";
    $itemlists=explode("|",$this->itemlist);
    for($i=0;$i<count($itemlists);$i++){
      $detailitem=explode("::",$itemlists[$i]);
      $message.= ($i+1)."\t".$detailitem[0]."\t".$detailitem[1]."\t".$this->intToCurrency($detailitem[3])."\t".$detailitem[2]."\t".$this->intToCurrency($detailitem[4])."\n";
    }
    $message.= "Total Order :\t\t\t\t".$this->intToCurrency($this->getTotalOrder())."\n\n";
    $message.= "Below is your contact information:\n";
    $message.= "Name   : ".$this->getInfo(0)."\n";
    $message.= "Email  : ".$this->getInfo(1)."\n";
    $message.= "Address: ".$this->getInfo(2)."\n";
    $message.= "Phone  : ".$this->getInfo(3)."\n";
    $message.= "\nThanks";
    $extraheader.="From: ".$this->getInfo(0)." <".$this->getInfo(1).">\r\n";
    $extraheader.="Reply-To: ".$this->getInfo(1)."\r\n";
    $extraheader.="X-Mailer: Hermawan Haryanto [hermawan@haryan.to]";
    @mail($to,$subject,$message,$extraheader);
  }
  function getTotalOrder(){
    $itemlists=explode("|",$this->itemlist);
    for($i=0;$i<count($itemlists);$i++){
      $detailitem=explode("::",$itemlists[$i]);
      $totalprice=$totalprice+$detailitem[4];
    }
    return $totalprice;
  }
  function isBasket(){
    if($this->userinfo) return true;
  }
  function printMenu(){
    return "<table width=\"100%\"><tr align=\"left\" class=\"subtitle\"><td>[<a href=\"./index.php\">Home</a> | <a href=\"./basket.php?act=list\">Your Order</a> | <a href=\"./list.php\">Product List</a>]</td></tr></table><hr>";
  }
  function isBadStr($str){
    if(strlen($str)>=4&&strlen($str)<=50){
      $valid_chars = " 0123456789_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
      for($i=0;$i<strlen($str);$i++){
        if(strchr($valid_chars,substr($str,$i,1))==false) $x++;
      }
      if($x>0) return true;
    }else{
      return true;
    }
  }
  function createBasket($forms){
    foreach($forms as $key=>$value){
      if($key=="info_fullname"&&trim($value)!="") $fullname=trim($value);
      if($key=="info_email"&&trim($value)!="") $email=trim($value);
      if($key=="info_address"&&trim($value)!="") $address=trim($value);
      if($key=="info_phone"&&trim($value)!="") $phone=trim($value);
    }
    $fullinfo=stripslashes("$fullname|$email|$address|$phone");
    $expiretime=time()+$this->expiretime;
    setcookie ("userinfo",$fullinfo,$expiretime);
  }
  function deleteBasket(){
    $this->clearInfo();
    $this->clearItem();
  }
  function clearInfo(){
    setcookie("userinfo","",time()-3600);
  }
  function clearItem(){
    setcookie("itemlist","",time()-3600);
  }
  function isEmpty(){
    if(trim($this->itemlist)==""||!$this->itemlist) return true;
  }
  function addToBasket($items){
    if($this->itemlist) $items=$this->itemlist."|".$items;
    setcookie ("itemlist",$items,$expiretime);
  }
  function getInfo($intInfo){
    if($this->userinfo){
      $infos=explode("|",$this->userinfo);
      $info=$infos[$intInfo];
      return $info;
    }
  }
  function intToCurrency($int){
    $cur="US$";
    return "$cur".number_format($int,2,",",".");
  }
  function printItems(){
    global $items;
    $rtn.="<table width=\"400\" border=\"0\" cellspacing=\"1\" cellpadding=\"2\" bgcolor=\"#0080C0\"><tr><td class=\"subtitle\">Item List</td></tr><tr><td class=\"body\" bgcolor=\"#FFFFFF\" align=\"left\" valign=\"top\"><table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"2\">";
    $rtn.="<form method=\"post\">";
    $rtn.="<tr align=\"left\" valign=\"top\" class=\"subtitle\" bgcolor=\"#D5F1FF\"><td width=\"20\">No.</td><td width=\"20\" align=\"center\">X</td><td width=\"50\" align=\"center\">Code</td><td >Name</td><td width=\"100\" align=\"center\">Price</td><td width=\"50\" align=\"center\">Quantity</td></tr>";
    for($i=0;$i<count($items);$i++){
      $rtn.=" <tr align=\"left\" valign=\"middle\" class=\"body\">
        <td width=\"20\">".($i+1)."</td>
        <td align=\"center\" width=\"20\"><input type=\"checkbox\" class=\"body\" name=\"item[]\" value=\"$i\"></td>
        <td width=\"50\">".$items[$i][code]."</td>
        <td>".$items[$i][name]."</td>
        <td width=\"100\">".$this->intToCurrency($items[$i][price])."</td>
        <td width=\"50\"><input type=\"text\" name=\"quantity[$i]\" size=\"4\" value=\"1\" class=\"body\"></td>
        </tr>";
      }
    $rtn.="</table><table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"2\" class=\"subtitle\"><tr><td align=\"right\" valign=\"top\">";
    $rtn.="<input type=\"submit\" name=\"action\" value=\"Select\" class=\"button\">";
    $rtn.="</td></tr></table></td></tr>";
    $rtn.="</form>";
    $rtn.="</table>";
    return $rtn;
  }
};
?>
